require 'spec_helper'


describe Recommender::Client do


  let(:api_key) { "e26b56a0-f08f-0131-ddaf-080027ab4d7b" }
  let(:add_param) {{type: 'article',engine_name: 'engine1',customer_id: 5,item_id: 2,action: 'Like'}}
  let(:client)  { Recommender::Client.connect(api_key)}
  let(:param_similar_users) {{engine_name: 'engine1',id: 1,n: 4}}
  let(:param_similar_items) {{type: 'article',engine_name: 'engine2',id: 1,n: 4}}

  describe '.connect' do
    context "When a application attemps to log in" do
    it{expect(Recommender::Client.connect(api_key)).to be_a Recommender::Client}
    end
  end

  describe '#add_item' do
    context "When an application wants to add new data" do
      it{expect(client.add_item(add_param)).to be_truthy}
    end
  end

  describe '#load_data' do
    context "When an application wants to load data" do
     it{expect(client.load_data(param_load('engine1'))).to be_truthy}
     it{expect(client.load_data(param_load('engine2'))).to be_truthy}
    end
  end

  describe '#get_similar_users' do
    context "When an application wants to get similar users" do
      it{expect(client.get_similar_users(param_similar_users)).to_not eq nil}
    end
  end

  describe '#get_similar_items' do
    context "When an application wants to get similar items" do
      it{expect(client.get_similar_items(param_similar_items)).to_not eq nil}
    end
  end

  describe '#get_recommandations' do
    context "When an application wants to get recommandations for a user" do
      it{expect(client.get_recommendations(param_similar_items)).to_not eq nil}
    end
  end


end
